﻿using System;
using System.Collections.ObjectModel;
using System.IO;
using System.Windows.Media.Imaging;
using System.ComponentModel;

namespace Sample.Models
{
    public class ItemGroup : INotifyPropertyChanged, INotifyPropertyChanging
    {
        public ItemGroup(string title)
        {
            
            Items = new ObservableCollection<Item>();
            Title = title;
        }

        public string Title { get; private set; }
        public System.Windows.Media.ImageSource Image { private get; set; }
        
        public ObservableCollection<Item> Items
        {
            get;
            private set;
        }

        private Item _SelectedItem;
        public Item SelectedItem
        {
            get
            {
                return _SelectedItem;
            }
            set
            {
                OnPropertyChanging("SelectedItem");
                _SelectedItem = value;
                OnPropertyChanged("SelectedItem");
                _SelectedItem.SelectView(_SelectedItem);
            }
        }
        
        #region INotifyPropertyChanged Members

        private void OnPropertyChanged(string prop)
        {

            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(prop));
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        #endregion

        #region INotifyPropertyChanging Members

        private void OnPropertyChanging(string prop)
        {
            if (PropertyChanging != null)
            {
                PropertyChanging(this, new PropertyChangingEventArgs(prop));
            }
        }

        public event PropertyChangingEventHandler PropertyChanging;

        #endregion
    }
}
